# fle-vue-boilerplate

A library project created by fle-cli.

## 构建命令

* `fle run dev` 开发模式，开启服务器，默认端口5000
* `fle run build` 编译lib和demo

## 目录结构

* public 示例代码
  * index.html 示例html文件
  * source 示例源码
  * dist 编译代码
* src js库源码，入口文件为index.js
* lib js库编译后代码
  * index.cjs.js commonjs模块
  * index.esm.js es6模块，保留npm引用
  * style.css 分离出的样式（如果有的话）

## 构建配置【fle.json】

```
{
  "type": "lib", // 项目类型，初始化生成后无需改动，否则会导致编译目标无法找到
  "iife": false, // 是否要导出自执行模块，否则导出es6和commonjs模块
  "eslint": true, // 是否开启eslint代码检测  
  "port": 5000, // 【dev】端口
  "hot": true, // 【dev】是否开启热更新
  "https": false, // 【dev】是否开启https
  "extract": false, // 是否需要编译css文件（若js库无css样式，建议关闭，减少冗余代码）
  "cssModules": true, // 是否开启css-modules（解决css嵌套和命名冲突的情况）
  "px2rem": false, // 是否将css中px转为rem，适用于移动端rem布局
  "remUnit": 50, // 1rem=50px
  "browsers": [
    "last 2 versions",
    "ie >= 9",
    "ios >= 7",
    "android >= 4"
  ]
}
```

## 扩展配置

需要自定义额外配置，可在项目根目录新建以下文件，系统会自动合并到默认配置

* .babelrc
* .eslintrc

## CSS样式

单位：

* px 正常输出
* rpx 转换为rem，默认1rem=50px