# fle-vue-boilerplate

A Vue.js project created by fle-cli.

## 构建命令

* `fle run dev` 开发模式，开启服务器，默认端口5000
* `fle run build` 生产模式，打包页面，生成dist文件夹

## 目录结构

* src 源码
  * common 公共文件
  * example 示例页面文件，新建页面参考此结构
    * app.json 页面配置
    * index.js 页面js入口
* index.html 默认页面模版，可参考此内容来新建模版
* dist 页面编译后生成的文件
* report 页面依赖分析（文件名为构建时间戳）

## 构建配置【fle.json】

```
{
  "type": "app", // 项目类型，初始化生成后无需改动，否则会导致编译目标无法找到
  "eslint": true, // 是否开启eslint代码检测
  "notify": true, // 【dev】当编译出错时是否开启系统通知
  "inlineManifest": true, // 【build】是否将manifest文件写入html
  "publicPath": "/", // 【build】编译后文件引用前缀

  "px2rem": false, // 是否将css中px转为rem，适用于移动端rem布局
  "remUnit": 50, // 1rem=50px

  "port": 5000, // 【dev】端口
  "proxy": {}, // 【dev】接口代理配置
  "hot": true, // 【dev】是否开启热更新
  "open": false, // 【dev】是否自动打开浏览器
  "https": false, // 【dev】是否开启https

  "css": [], // css外链
  "prejs": [], // 预加载的js外链，位于head
  "js": [], // 加载js外链，位于body

  "alias": { // js引用别名配置
    "@": "src"
  },
  "externals": {}, // 忽略引用，转而使用全局变量
  "browsers": [ // 需要兼容的浏览器配置
    "last 2 versions",
    "ie >= 9",
    "ios >= 7",
    "android >= 4"
  ]
}
```

## 页面配置【app.json】

```
{
  "title": "示例", // 页面标题
  "keyswords": "example", // 页面关键词
  "description": "示例页面", // 页面描述
  "icon": "https://easyread.nosdn.127.net/web/trunk/1519626068077/logo.png", // 页面icon
  "template": "index.html", // 页面模版，也可以自行扩展，或者/开头来使用系统配置好的模版，如：/default.html
  "css": [], // 若长度不为空则覆盖fle.json中的css全局配置
  "prejs": [], // 同上
  "js": [], // 同上
  "compiled": true // 是否要编译本页面，若为false则不编译
}
```

备注：除以上字段外，可以额外添加字段，在html模版中通过以下方式获取：如额外添加name，则htmlWebpackPlugin.options.app['name']可以获取该值

## 扩展配置

需要自定义额外配置，可在项目根目录新建以下文件，系统会自动合并到默认配置

* webpack.config.js
* .babelrc
* .eslintrc

## CSS样式

单位：

* px 正常输出
* rpx 转换为rem，默认1rem=50px